QGIS Application - Bug report #8369
Null propagation of fields in expression based labelling
2013-07-27 05:00 PM - Patrick Dunford

Status: Closed

Priority: Normal

Assignee:

Category: Labelling

Affected QGIS version:master Regression?: No
Operating System: Easy fix?: No

Pull Request or Patch supplied: Resolution: duplicate
Crashes QGIS or corrupls data: Copied to github as #: 17146
Description

In one of my shapefiles | have an expression based label.

The expression is

"refName" || "\

"|| "refDetail" || "\

"|| "refSource" || \

"I "refURL" || \

"|| "refDate"

So it is concatenating five fields in the attribute table along with newlines to format the label.

The problem is that if any of these fields are null, the entire label is not being displayed.
This is presumably from null propagation - one null makes the entire expression result null.

It should be feasible for the expression evaluator to evaluate each field value individually and exclude any nulls from being put into the
final result.

Related issues:

Duplicates QGIS Application - Feature request # 7510: NULL string should be v... Closed 2013-04-04
Duplicated by QGIS Application - Bug report # 8457: $length fails silently fo... Closed 2013-08-12
History

#1 - 2013-07-27 05:09 PM - Nathan Woodrow

- OS version deleted (8)

- Operating System deleted (Windows)

String + NULL = NULL. We don't treat NULL as empty string because it's not correct to do so. NULL and empty mean two different things so are treated
differently.

The best way to handle this is using the coalesce function

"o

coalesce("refName",")
If refName is null then a empty string is returned. You expression would look like this:

coalesce("refName",") || "\

" || coalesce("refDetail",") || "\
"|| coalesce("refSource”,") || \
"|| coalesce("refURL",") || "\
"|| coalesce("refDate" ,")
You can also use the format function in order to clean that up

format('%1\
%2\
%3\
%od\

%5',coalesce("refName","), coalesce("refDetail","), coalesce("refSource","), coalesce("refURL","), coalesce("refDate" ,"))
#2 - 2013-07-27 11:57 PM - Jiirgen Fischer
- Resolution set to duplicate
- Status changed from Open to Closed

duplicate of #7510
